<?php
namespace Incoviba\Repository\Venta;

use Incoviba\Common\Ideal;
use Incoviba\Common\Define;
use Incoviba\Common\Implement;
use Incoviba\Model;

class BonoPie extends Ideal\Repository
{
    public function __construct(Define\Connection $connection, protected Pago $pagoRepository)
    {
        parent::__construct($connection);
        $this->setTable('bono_pie');
    }

    public function create(?array $data = null): Define\Model
    {
        $map = (new Implement\Repository\MapperParser(['valor']))
            ->register('pago', (new Implement\Repository\Mapper())
                ->setFunction(function($data) {
                    return $this->pagoRepository->fetchById($data['pago']);
                }));
        return $this->parseData(new Model\Venta\BonoPie(), $data, $map);
    }
    public function save(Define\Model $model): Define\Model
    {
        $model->id = $this->saveNew(
            ['valor', 'pago'],
            [$model->pago->valor, $model->pago->id]
        );
        return $model;
    }

    /**
     * @param Define\Model $model
     * @param array $new_data
     * @return Define\Model
     * @throws Implement\Exception\EmptyResult
     */
    public function edit(Define\Model $model, array $new_data): Define\Model
    {
        return $this->update($model, ['valor', 'pago'], $new_data);
    }

    /**
     * @param float $value
     * @return array
     * @throws Implement\Exception\EmptyResult
     */
    public function fetchByValue(float $value): array
    {
        $query = $this->connection->getQueryBuilder()
            ->select()
            ->from($this->getTable())
            ->where('valor = ?');
        return $this->fetchMany($query, [$value]);
    }

    /**
     * @param int $pago_id
     * @return Model\Venta\BonoPie
     * @throws Implement\Exception\EmptyResult
     */
    public function fetchByPago(int $pago_id): Model\Venta\BonoPie
    {
        $query = $this->connection->getQueryBuilder()
            ->select()
            ->from($this->getTable())
            ->where('pago = ?');
        return $this->fetchOne($query, [$pago_id]);
    }

    /**
     * @param int $venta_id
     * @return Model\Venta\BonoPie
     * @throws Implement\Exception\EmptyResult
     */
    public function fetchByVenta(int $venta_id): Model\Venta\BonoPie
    {
        $query = $this->connection->getQueryBuilder()
            ->select('a.*')
            ->from("{$this->getTable()} a")
            ->joined('JOIN venta ON venta.bono_pie = a.id')
            ->where('venta.id = ?');
        return $this->fetchOne($query, [$venta_id]);
    }

    public function filterData(array $data): array
    {
        return array_intersect_key($data, array_flip(['valor', 'pago']));
    }
}
